
/*******************************************************************************
*
* File aflds.h
*
* Copyright (C) 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef AFLDS_H
#define AFLDS_H

#ifndef SU3_H
#include "su3.h"
#endif

typedef struct
{
   int na0,nak;
   int *ia0,*iak;
} aidx_t;

/* ADCOM_C */
extern void copy_bnd_ad(int n,su3_alg_dble *ad);
extern void add_bnd_ad(int n,su3_alg_dble *ad);
extern void gather_bnd_ad0(su3_alg_dble *ad);
extern void scatter_bnd_ad0(su3_alg_dble *ad);

/* ADMAP_C */
extern void gather_afld(su3_alg_dble *ad,su3_alg_dble **sad);
extern void scatter_afld(su3_alg_dble **sad,su3_alg_dble *ad);

/* ADSHIFT_C */
extern int shift_ad(int *s,su3_alg_dble *ad);

/* AIDX_C */
extern aidx_t *aidx(void);
extern void plaq_aidx(int n,int ix,int *ip);

/* APROP_C */
extern void aprop(su3_alg_dble *src,su3_alg_dble *fld);
extern void random_asrc(su3_alg_dble *fld);

/* DIVAD_C */
extern void divad(su3_alg_dble *ad,su3_alg_dble *cd);
extern double gfix_action(su3_alg_dble *ad1,su3_alg_dble *ad2);

/* PLAQ_ACTION_C */
extern double plaq_action(su3_alg_dble *ad1,su3_alg_dble *ad2);

#endif
