
/*******************************************************************************
*
* File su3fcts.h
*
* Copyright (C) 2010, 2011, 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef SU3FCTS_H
#define SU3FCTS_H

#ifndef SU3_H
#include "su3.h"
#endif

/* CM3X3_C */
extern void cm3x3_zero(int vol,su3_dble *u);
extern void cm3x3_unity(int vol,su3_dble *u);
extern void cm3x3_assign(int vol,su3_dble *u,su3_dble *v);
extern void cm3x3_swap(int vol,su3_dble *u,su3_dble *v);
extern void cm3x3_dagger(int vol,su3_dble *u,su3_dble *v);
extern void cm3x3_tr(su3_dble *u,su3_dble *v,complex_dble *tr);
extern void cm3x3_retr(su3_dble *u,su3_dble *v,double *tr);
extern void cm3x3_imtr(su3_dble *u,su3_dble *v,double *tr);
extern void cm3x3_add(su3_dble *u,su3_dble *v);
extern void cm3x3_sub(su3_dble *u,su3_dble *v);
extern void cm3x3_mul_add(su3_dble *u,su3_dble *v,su3_dble *w);
extern void cm3x3_mul_sub(su3_dble *u,su3_dble *v,su3_dble *w);
extern void cm3x3_mulr(double *r,su3_dble *u,su3_dble *v);
extern void cm3x3_mulr_add(double *r,su3_dble *u,su3_dble *v);
extern void cm3x3_mulc(complex_dble *c,su3_dble *u,su3_dble *v);
extern void cm3x3_mulc_add(complex_dble *c,su3_dble *u,su3_dble *v);
extern void cm3x3_lc1(complex_dble *c,su3_dble *u,su3_dble *v);
extern void cm3x3_lc2(complex_dble *c,su3_dble *u,su3_dble *v);
extern void cm3x3_mul_poly(int n,su3_dble *u,su3_dble *v,su3_dble *w);
extern void cm3x3_varmul_poly(int n,su3_dble *u,su3_dble *v,su3_dble *w);
extern void cm3x3_inv_poly(int n,su3_dble *u,su3_dble *v);
extern void cm3x3_log_poly(int n,su3_dble *u,su3_dble *v);
extern double cm3x3_devsl3_poly(int n,su3_dble *u);
extern double cm3x3_devsu3_poly(int n,su3_dble *u);
extern void cm3x3_ren2sl3_poly(int n,su3_dble *u);
extern void cm3x3_ren2su3_poly(int n,su3_dble *u);

/* RANDOM_SU3_C */
extern void random_su3_dble(su3_dble *u);

/* SU3ALG_C */
extern void su3alg_zero(su3_alg_dble *a);
extern void su3alg_add(su3_alg_dble *a,su3_alg_dble *b);
extern void su3alg_sub(su3_alg_dble *a,su3_alg_dble *b);
extern void su3alg_mulr(double *r,su3_alg_dble *a,su3_alg_dble *b);
extern void su3alg_mulr_add(double *r,su3_alg_dble *a,su3_alg_dble *b);
extern void su3alg_to_su3(su3_alg_dble *a,su3_dble *u);
extern void su3_to_su3alg(su3_dble *u,su3_alg_dble *a);
extern void su3_mulr_add_su3alg(double *r,su3_dble *u,su3_alg_dble *a);
extern void pexp_su3alg(int n,su3_alg_dble *a,su3_dble *u);
extern void mexp_su3alg(int n,su3_alg_dble *a,su3_dble *u);
extern double su3alg_biform(su3_alg_dble *a,su3_alg_dble *b);
extern void u3alg_zero(u3_alg_dble *a);
extern void u3alg_add(u3_alg_dble *a,u3_alg_dble *b);
extern void u3alg_sub(u3_alg_dble *a,u3_alg_dble *b);
extern void u3alg_mulr(double *r,u3_alg_dble *a,u3_alg_dble *b);
extern void u3alg_mulr_add(double *r,u3_alg_dble *a,u3_alg_dble *b);
extern void u3alg_to_su3(u3_alg_dble *a,su3_dble *u);
extern void su3_to_u3alg(su3_dble *u,u3_alg_dble *a);
extern void u3alg_to_su3alg(u3_alg_dble *a,su3_alg_dble *b);

/* SU3PROD_C */
extern void su3xsu3(su3_dble *u,su3_dble *v,su3_dble *w);
extern void su3dagxsu3(su3_dble *u,su3_dble *v,su3_dble *w);
extern void su3xsu3dag(su3_dble *u,su3_dble *v,su3_dble *w);
extern void su3dagxsu3dag(su3_dble *u,su3_dble *v,su3_dble *w);
extern void su3xu3alg(su3_dble *u,u3_alg_dble *X,su3_dble *v);
extern void su3dagxu3alg(su3_dble *u,u3_alg_dble *X,su3_dble *v);
extern void u3algxsu3(u3_alg_dble *X,su3_dble *u,su3_dble *v);
extern void u3algxsu3dag(u3_alg_dble *X,su3_dble *u,su3_dble *v);
extern double prod2su3alg(su3_dble *u,su3_dble *v,su3_alg_dble *X);
extern void prod2u3alg(su3_dble *u,su3_dble *v,u3_alg_dble *X);
extern void rotate_su3alg(su3_dble *u,su3_alg_dble *X);

#endif
